---
title: Parameter Reference
weight: 1
---

Vitastor configuration consists of:
- Configuration parameters (key-value), described here
- [Pool configuration]({{< ref "config/pool" >}})
- OSD placement tree configuration
- Inode configuration i.e. image metadata like name, size and parent reference

Configuration parameters can be set in 3 places:
- Configuration file (`/etc/vitastor/vitastor.conf` or other path)
- etcd key `/vitastor/config/global`. Most variables can be set there, but etcd
  connection parameters should obviously be set in the configuration file.
- Command line of Vitastor components: OSD, mon, fio and QEMU options,
  OpenStack/Proxmox/etc configuration. The latter doesn't allow to set all
  variables directly, but it allows to override the configuration file and
  set everything you need inside it.

In the future, additional configuration methods may be added:
- OSD superblock which will, by design, contain parameters related to the disk
  layout and to one specific OSD.
- OSD-specific keys in etcd like `/vitastor/config/osd/<number>`.

## Common Parameters

These are the most common parameters which apply to all components of Vitastor.

[See the list]({{< ref "common" >}})

## Cluster-Wide Disk Layout Parameters

These parameters apply to clients and OSDs and can't be changed after OSD
initialization.

[See the list]({{< ref "layout-cluster" >}})

## OSD Disk Layout Parameters

These parameters apply to OSDs and can't be changed after OSD initialization.

[See the list]({{< ref "layout-osd" >}})

## Network Protocol Parameters

These parameters apply to clients and OSDs and can be changed with a restart.

[See the list]({{< ref "network" >}})

## Runtime OSD Parameters

These parameters apply to OSDs and can be changed with an OSD restart.

[See the list]({{< ref "osd" >}})

## Monitor Parameters

These parameters only apply to Monitors.

[See the list]({{< ref "monitor" >}})
