---
title: Перечень настроек
weight: 1
---

Конфигурация Vitastor состоит из:
- Параметров (ключ-значение), описанных на данной странице
- Настроек пулов
- Настроек дерева OSD
- Настроек инодов, т.е. метаданных образов, таких, как имя, размер и ссылки на
  родительский образ

Параметры конфигурации могут задаваться в 3 местах:
- Файле конфигурации (`/etc/vitastor/vitastor.conf` или по другому пути)
- Ключе в etcd `/vitastor/config/global`. Большая часть параметров может
  задаваться там, кроме, естественно, самих параметров соединения с etcd,
  которые должны задаваться в файле конфигурации
- В командной строке компонентов Vitastor: OSD, монитора, опциях fio и QEMU,
  настроек OpenStack, Proxmox и т.п. Последние, как правило, не включают полный
  набор параметров напрямую, но разрешают определить путь к файлу конфигурации
  и задать любые параметры в нём.

В будущем также могут быть добавлены другие способы конфигурации:
- Суперблок OSD, в котором будут храниться параметры OSD, связанные с дисковым
  форматом и с этим конкретным OSD.
- OSD-специфичные ключи в etcd типа `/vitastor/config/osd/<номер>`.

## Общие параметры

Это наиболее общие параметры, используемые всеми компонентами Vitastor.

[Посмотреть список]({{< ref "common" >}})

## Дисковые параметры уровня кластера

Эти параметры используются клиентами и OSD и не могут быть изменены после
инициализации OSD.

[Посмотреть список]({{< ref "layout-cluster" >}})

## Дисковые параметры OSD

Эти параметры используются OSD и не могут быть изменены после инициализации OSD.

[Посмотреть список]({{< ref "layout-osd" >}})

## Параметры сетевого протокола

Эти параметры используются клиентами и OSD и могут быть изменены с перезапуском.

[Посмотреть список]({{< ref "network" >}})

## Изменяемые параметры OSD

Эти параметры используются OSD и могут быть изменены с перезапуском.

[Посмотреть список]({{< ref "osd" >}})

## Параметры мониторов

Данные параметры используются только мониторами Vitastor.

[Посмотреть список]({{< ref "monitor" >}})
